<?php
function ama_create_similar_posttables($AffiliateId, $CampaignID, $asin_code, $camposttype="similar", $existing_post_ID) {

    @ini_set('memory_limit', '256M');
    @set_time_limit(0);
    global $wpdb;
    $data_product = array();
    $count = 0;
    $sql = "select * from " . $wpdb->prefix . "ama_option ";
    $api_data = $wpdb->get_results($sql);
    foreach ($api_data as $apidata) {
        $PublicKey = $apidata->api_key;
        $PrivateKey = $apidata->secret_api_key;
        $des_length = $apidata->amazon_des_length;
        $aff_web = $apidata->amazon_web;
    }
    $first_count = 0;
    $error_count = 0;
    $error_message = array();
    $product_error = "";
    $finished = false;
    $page = 1;
    $post_ID = $existing_post_ID;


        usleep(1200000);
        if ($asin_code != "") {
            $xml = ama_aws_request($PrivateKey, $PublicKey, array("Operation" => "ItemLookup",
                "ItemId" => $asin_code,
                "ResponseGroup" => "Large,VariationSummary",
                "AssociateTag" => $AffiliateId), $aff_web);
        }
        if (isset($xml->Items->Request->Errors->Error->Code) || isset($xml->Error->Code) || isset($xml['error']['message'])) { //CRT - This is the correct way to grab the error code and error message from the $xml object
            if (isset($xml->Items->Request->Errors->Error->Code)) {
                if ($xml->Items->Request->Errors->Error->Code == 'AWS.InvalidAccount') {
                    $error_message['message'] = '<b>Your Amazon Associates Account is not set up for API use - Please go <a href="https://affiliate-program.amazon.com/gp/flex/advertising/api/sign-in.html" target="_blank">here</a> and complete the registration process.</b>'; }
                elseif ($xml->Items->Request->Errors->Error->Code == 'AWS.ECommerceService.NoExactMatches') {
                    $error_message['message'] = '<b>Amazon did not find any matches for your keyword in that category/node that are in your price range.  Please check them and try again.</b>'; }
                else {
                    $error_message['message'] = '<b>' . $xml->Items->Request->Errors->Error->Code . ' -- ' . $xml->Items->Request->Errors->Error->Message . '</b>'; }
            } elseif (isset($xml->Error->Code)) { // This is required because some responses are not as well formed as the others.
                if ($xml->Error->Code == 'SignatureDoesNotMatch') {
                    $error_message['message'] = '<b>There is an error in your Amazon API settings -- <a href="https://affiliate-program.amazon.com/gp/advertising/api/detail/your-account.html" target="_blank">Click here</a> to check your keys, and re-enter them on the <a href="/wp-admin/admin.php?page=amazone_setting">Amazon Settings page</a>.</b><br/>'; }
                else {
                    $error_message['message'] = '<b>' . $xml->Error->Code . ' -- ' . $xml->Error->Message . '</b><br/>'; }
            }
            else {
                $error_message['message'] = '<b>Host not found</b>';
            }
            $finished = true;
        } else {

            foreach ($xml->Items->Item as $item) {
                    $htacessurl = get_bloginfo('home') . '/product/' . $item->ASIN . '/';
                    $product_title = $item->ItemAttributes->Title[0];
                    //$items = explode(' ', $post_title);
                $pageAsin = '';
                $pageAsin.=(string) $item->ASIN . ',';
                    if ($camposttype == "similar") {
                        update_post_meta($existing_post_ID, 'similar_product', $item->ItemAttributes->Title);
                        update_post_meta($post_ID, 'amazon_image_alt', (string) $item->ItemAttributes->Title);
                    }
                    $countpost[] = array('ASIN' => $item->ASIN, 'post_ID' => $post_ID);
                    $arrayInsert = array(
                        'campid' => $CampaignID,
                        'asin' => $item->ASIN,
                        'title' => $item->ItemAttributes->Title[0],
                        'link' => $item->DetailPageURL,
                        'imgurl' => $item->MediumImage->URL[0],
                        'clockurl' => $htacessurl,
                        'web' => $aff_web,
                        'affid' => $AffiliateId,
                        'camtype' => 4
                    );
                    ama_save_campaign($arrayInsert, "ama_camp_prodata");
                }
            }
    if (count($countpost) == 0 && count($error_message) == 0 && !(isset($error_message['message']))) {
        $error_message['message'] = $xml->Items->Request->Errors->Error->Code . ' - ' . 	$xml->Items->Request->Errors->Error->Message; // CRT - Again, we are getting the error code and error message from the object.
    }

    return $error_message;
}
