<?php

function ama_getfuture_post() {
    global $wpdb;
    $sql = "SELECT * FROM " . $wpdb->prefix . "ama_campaigns WHERE cam_timetype=1 AND NOW()>cam_created_time";
    $result = $wpdb->get_results($sql);
    if ($result) {
        foreach ($result as $campdata) {
            if ($campdata->campost_type == "page") {
                $page_name = $campdata->campagename;
                $new_post = array(
                    'post_title' => $page_name,
                    'post_type' => 'page',
                    'post_content' => $page_name,
                    'post_status' => 'publish',
                    'post_author' => get_current_user_id()
                );
                $cam_parent_page = wp_insert_post($new_post);
            }
            $message_error = ama_create_post_posttables($campdata->cam_interval_type, $campdata->cam_interval, $campdata->cam_categories, $campdata->cam_keywords, 'yes', $campdata->cam_department, $campdata->cam_number_post, $campdata->cam_apiid, $campdata->cam_encoding, $campdata->cam_browsenode, $campdata->cam_id, $campdata->cam_minprice, $campdata->cam_maxprice, $cam_parent_page, $campdata->cam_asin_code, $campdata->campost_type, $campdata->cam_postformat, $campdata->cam_btnformat, $campdata->video);
            if (!isset($message_error['message'])) {
                $message = $message_error['message'];
                $wpdb->query("update  " . $wpdb->prefix . "ama_campaigns set cam_post_created='" . $message_error['num_post'] . "',cam_timetype=0 where cam_id=" . $campdata->cam_id);
            }
        }
    }
}

add_action('init', 'ama_getfuture_post');
?>
