<?php

/*
  Plugin Name: WP Amaz-One PLUS
  Plugin URI: http://wp-amazone.com/
  Description: Your amazing All-In-One Amazon auto posting and traffic solution.
  Version: 1.0+
  Author: Lisa Gergets and Carl Thorpe
  Author URI: http://wp-amazone.com/
 */
?>
<?php

define('AMAZON_URL', WP_CONTENT_URL . '/plugins/' . plugin_basename(dirname(__FILE__)) . '/');
include('updatedb.php');
include('create_post.php');
include('ama_popupcamp.php');
include('ama_function.php');
include('ama_unzip.php');
include('ama-uniquifypost.php');
include('bannercamp.php');
include('ama-shortcode.php');
include('ama_futurepost.php');
//if (!class_exists('FacebookApiException'))
   // include('facebookapi/facebook.php');
//if (!class_exists('Twitter'))
    //include('twitter/class.php');

$ama_version = '3.0b3';

add_action('init', 'ama_set_js', 1);

function amazone_add_options_page() {
    add_menu_page(__('General Setting'), __('<span style="margin-left:-22px">WP Amaz-One PLUS</span>'), 'edit_themes', 'ama_general_setting', 'ama_general_setting_page', 'NULL');
    add_submenu_page('ama_general_setting', __('General Settings'), __('General Settings'), 'edit_themes', 'ama_general_setting', 'ama_general_setting_page');
    //add_submenu_page('ama_general_setting', __('Amazon Settings'), __('Amazon Settings'), 'edit_themes', 'amazone_setting', 'ama_option_page');
    add_submenu_page('ama_general_setting', __('Create Campaign'), __('Create Campaign'), 'edit_themes', 'create_campaigns', 'ama_create_campaigns');
    add_submenu_page('', __('Campaigns'), __('<span style="display:none">Campaign List</span>'), 'edit_themes', 'campaign_list', 'ama_list_campaigns');
    add_submenu_page('ama_general_setting', __('Create Presets'), __('Create Presets'), 'edit_themes', 'create_presets', 'ama_preconfigure_campaigns');
    add_submenu_page('', __('List Presets'), __('<span style="display:none">Current Presets</span>'), 'edit_themes', 'current_presets', 'ama_list_presets');
    add_submenu_page('ama_general_setting', __('Create Text Banners'), __('Create Text Banners'), 'edit_themes', 'create_banner_campaigns', 'ama_create_banner_campaigns');
    add_submenu_page('options.php', __('Text Banner List'), __('Text Banner List'), 'edit_themes', 'banner_list', 'ama_list_banner_campaigns');
    add_submenu_page('ama_general_setting', __('Create Text Links'), __('Create Text Links'), 'edit_themes', 'create_popup_campaigns', array('ama_popupcamp', 'addCamp'));
    add_submenu_page('options.php', __('Text Link Campaign List'), __('Text Link Campaign List'), 'edit_themes', 'amazone_popup_campaigns', array('ama_popupcamp', 'listCamp'));
//    add_submenu_page('ama_general_setting', __('Twitter Settings'), __('Twitter Auto-Posting'), 'edit_themes', 'twittet_setting', 'ama_twitteroption_page');
//    add_submenu_page('ama_general_setting', __('Facebook Settings'), __('Facebook Auto-Posting'), 'edit_themes', 'facebook_setting', 'ama_facebookoption_page');
    add_submenu_page('ama_general_setting', __('Update Links'), __('Update Links'), 'edit_themes', 'update_links', 'ama_updateTag');
//    add_submenu_page('ama_general_setting', __('Clone Deployment'), __('Clone Deployment'), 'edit_themes', 'clone_deployment', 'ama_cloneDeploy');
    add_submenu_page('ama_general_setting', __('Tutorial Videos'), __('Tutorial Videos'), 1, 'ama_tutorial', 'ama_tutorial');
    add_submenu_page('ama_general_setting', __('Update Plugin'), __('Update Plugin'), 1, 'ama_upgrade_plugin', 'ama_upgrade_plugin_page');
    add_submenu_page('ama_general_setting', __('Update Plugin'), __(''), 1, 'ama_upgrade_success', 'ama_upgrade_success_page');
//    add_submenu_page('', __('Text Banner Ads'), __(''), 1, 'ama_camp_banner_list', 'ama_camp_banner_list');
//    add_submenu_page('', __('Text Link Banner Ads'), __(''), 1, 'ama_pop_product', array('ama_popupcamp', 'campPro'));
    wp_enqueue_script('amazone_api', AMAZON_URL . 'js/script.js');
    wp_enqueue_script('jquery');
    wp_enqueue_script('jquery-ui-core');
    wp_enqueue_script('ama-datepicker-js', AMAZON_URL . '/js/jquery.datepicker.js');
    wp_enqueue_style('amazone_api_css', AMAZON_URL . 'css/style.css');
    wp_enqueue_style('amazone_datepicker_css', AMAZON_URL . 'css/jquery.ui.all.css');
    wp_enqueue_style('farbtastic');
    wp_enqueue_script('farbtastic');
}

function ama_set_js() {
    wp_enqueue_script('ama-js', AMAZON_URL . '/js/IFrame.js');
    wp_enqueue_style('amazone_api', AMAZON_URL . 'css/amazon.css');
}

//if (!isset($_POST['ama_tagsubmit']))
//    add_action('publish_post', 'ama_twitter_autopost');

if (get_option('admin_menu') == 'amazone_add_options_page')
    update_action('admin_menu', 'amazone_add_options_page');
else
    add_action('admin_menu', 'amazone_add_options_page');

define('MISSEDSCHEDULED_DELAY', 2);

function ama_missed_schedule_init() {
    global $wpdb;
    $last = get_option('missed_schedule', false);
    if (($last !== false) && ($last > (time() - (MISSEDSCHEDULED_DELAY * 60))))
        return;
    update_option('missed_schedule', time());
    $missedIDs = $wpdb->get_col("SELECT `ID` FROM `{$wpdb->posts}` " . "WHERE ( " . "    ( " . "    ((`post_date_gmt` > 0) && (`post_date_gmt` <= UTC_TIMESTAMP())) " . ")) AND `post_status` = 'future'");
    if (!count($missedIDs))
        return;
    foreach ($missedIDs as $missedID) {
        if (!$missedID)
            continue;
        wp_publish_post($missedID);
    }
}

function ama_run_updates() {
    if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
        ama_alter_table();
    }
}

function ama_pop_up() {
    global $wpdb;
    $qry = 'SELECT * from ' . $wpdb->prefix . 'ama_general_settings';
    $option_data = $wpdb->get_row($qry);
    $enable_popup = $option_data->enable_popup;
    $popup_id = $option_data->popup_id;
    $popup_delay = $option_data->popup_delay;
    $popup_bg = $option_data->popup_bg;
    $popup_txt = $option_data->popup_txt;
    $popup_bd = $option_data->popup_bd;
    $popup_rm = $option_data->popup_rm;
    $qry = 'SELECT amazon_web from ' . $wpdb->prefix . 'ama_option';
    $option_data = $wpdb->get_row($qry);
    $ama_web = $option_data->amazon_web;
    if($ama_web == '') $ama_web = 'com';
    if($enable_popup) {
        ?>
        <div id="slidebox" style="background-color: <?php echo $popup_bg; ?>;border: <?php echo $popup_bd; ?> 3px solid">
        <a class="close"></a>
        <p><h2 style="color: <?php echo $popup_txt; ?>">Shop for more products at <a style="color: <?php echo $popup_rm; ?>" target="_blank" href='http://www.amazon.<?php echo $ama_web; ?>/?linkCode=ur2&tag=<?php echo $popup_id;?>'>Amazon</a>!</h2></p>
        </div>
        <script type="text/javascript">

        var $j = jQuery.noConflict();
        $j(function() {
        $j(document).ready(function(){
        $j('#slidebox').delay(<?php echo $popup_delay * 1000; ?>).fadeIn('7000');
        });

        /* remove the slidebox when clicking the cross */
        $j('#slidebox .close').bind('click',function(){
        $j(this).parent().remove();
        });
        });
        </script>
        <?php
    }
}

add_action('init', 'ama_run_updates', 1);
add_action('init', 'ama_missed_schedule_init', 0);
$plugin = plugin_basename(__FILE__);
$plugin_data = "this is plugin flle $plugin";
$context = "this is plugin flle $plugin";
add_filter('the_excerpt', 'do_shortcode', 11);
add_filter('the_content', 'do_shortcode', 11);
add_action('wp_footer', 'ama_pop_up', 12);
?>