<?php

function ama_create_banner_campaigns() {
    global $wpdb;
    if (isset($_POST['submit'])) {
        $arrRemove = array('submit');
        $saveData = array();
        foreach ($_POST as $key => $value) {
            if (in_array($key, $arrRemove)
            )
                continue;
            $saveData[$key] = $value;
        }
        $insertid = ama_save_campaign($saveData, "ama_bannercamp");
        if ($insertid) {
            ama_get_banner_product($_POST['keyword'], $_POST['amadep'], $_POST['affid'], $insertid);
        }
    }
    include_once 'pages/banner_campaign.php';
}

function ama_list_banner_campaigns() {
    global $wpdb;
    if (isset($_GET['mode']) && $_GET['mode'] == "delete") {
        $sql = "DELETE FROM `" . $wpdb->prefix . "ama_bannercamp` WHERE id='" . $_GET['id'] . "'";
        $wpdb->query($sql);
        $sql = "DELETE FROM `" . $wpdb->prefix . "ama_bannercamp_product` WHERE camp_id='" . $_GET['id'] . "'";
        $wpdb->query($sql);
        $sql = "DELETE FROM `" . $wpdb->prefix . "ama_bannerpro_relation` WHERE campid='" . $_GET['id'] . "'";
        $wpdb->query($sql);
    }
    include_once 'pages/banner_list.php';
}

function ama_get_banner_product($keyword, $department, $AffiliateId, $insertid) {
    @ini_set('memory_limit', '256M');
    @set_time_limit(0);
    global $wpdb;
    $data_product = array();
    $count = 0;
    $sql = "select * from " . $wpdb->prefix . "ama_option ";
    $api_data = $wpdb->get_results($sql);
    foreach ($api_data as $apidata) {
        $PublicKey = $apidata->api_key;
        $PrivateKey = $apidata->secret_api_key;
        $des_length = $apidata->amazon_des_length;
        $aff_web = $apidata->amazon_web;
    }
    $post_category = array($category2);
    $first_count = 0;
    $error_count = 0;
    $error_message = "";
    $product_error = "";
    $countpost = array();
    $finished = false;
    $page = 1;
    $post_ID = 0;
    $pagecontent = "";
    do {
        $time_start = microtime(true);
        if(isset($runtime) && $runtime < 1) {
            $time_to_sleep = round((1 - $runtime) * 1000000) + 1;
            echo "<span style='font-size:8px'>. </span>";
            //echo "<br/>time_to_sleep = $time_to_sleep";
            usleep($time_to_sleep);
        }
        if ($department == "All") {
            $xml = ama_aws_request($PrivateKey, $PublicKey, array("Operation" => "ItemSearch",
                "IdType" => "ASIN",
                "MerchantId" => "All",
                "ResponseGroup" => "EditorialReview,Similarities,Small,Request,OfferListings,Images,VariationSummary",
                "SearchIndex" => $department,
                "Keywords" => $keyword,
                "ItemPage" => $page,
                "AssociateTag" => $AffiliateId), $aff_web);
        } else {
            $xml = ama_aws_request($PrivateKey, $PublicKey, array("Operation" => "ItemSearch",
                "IdType" => "ASIN",
                "MerchantId" => "All",
                "ResponseGroup" => "EditorialReview,Similarities,Small,Request,OfferListings,Images,VariationSummary",
                "SearchIndex" => $department,
                "Keywords" => $keyword,
                "ItemPage" => $page,
                "AssociateTag" => $AffiliateId), $aff_web);
        }
            if (isset($xml->Items->Request->Errors->Error->Code) || isset($xml->Error->Code) || isset($xml['error']['message'])) {
                if (isset($xml->Items->Request->Errors->Error->Code)) {
                    $error_message['message'] = '<b>' . $xml->Items->Request->Errors->Error->Code . ' -- ' . $xml->Items->Request->Errors->Error->Message . '</b>';
                      if ($xml->Items->Request->Errors->Error->Code == 'AWS.InvalidAccount') { $error_message['message'] .= ' <a href="https://affiliate-program.amazon.com/gp/flex/advertising/api/sign-in.html">Click here to follow link</a>';}
                } elseif (isset($xml->Error->Code)) {
                   $error_message['message'] = '<b>' . $xml->Error->Code . ' -- ' . $xml->Error->Message . '</b><br/>';
                }
                 else {
                    $error_message['message'] = '<b>Host not found</b>';
                }
                $finished = true;
        } else {
            foreach ($xml->Items->Item as $item) {
                $LowestPrice = ama_getamazonprice($item);
                $pricetypearray = array('$', '£', 'EUR', ',', 'CDN', '￥', "Â");
                $price = (float) str_replace($pricetypearray, '', $LowestPrice);
                if (isset($item->EditorialReviews->EditorialReview->Content) && isset($item->MediumImage->URL) && $LowestPrice != null) {
                    if($item->Offers->TotalOffers == 0) {
                        $buylink = $item->DetailPageURL;
                    } else {
                        $buylink = 'http://www.amazon.' . $aff_web . '/gp/aws/cart/add.html?ASIN.1=' . $item->ASIN . '&Quantity.1=1&AssociateTag=' . $AffiliateId . '&AWSAccessKeyID=' . $PublicKey;
                    }
                    $arrproduct['camp_id'] = $insertid;
                    $arrproduct['title'] = $item->ItemAttributes->Title;
                    $arrproduct['desc'] = $item->EditorialReviews->EditorialReview->Content[0];
                    $arrproduct['price'] = (string) $LowestPrice;
                    $arrproduct['link'] = $buylink;
                    $arrproduct['date'] = time();
                    $arrproduct['asin'] = $item->ASIN;
                    $arrproduct['affweb'] = $aff_web;
                    $arrproduct['clocklink'] = get_bloginfo('home') . "/amazone/" . $item->ASIN;
                    ama_save_campaign($arrproduct, "ama_bannercamp_product");
                    $count++;
                }
                if ($count >= 10) {
                    $finished = true;
                    break;
                }
            }

            if($department == 'All') $maxpagesallowed = 5;
            else $maxpagesallowed = 10;
            if ($page >= $maxpagesallowed) {
                $finished = true;
                break;
            }
        }
        $page++;
        $time_end = microtime(true);
        $runtime = $time_end - $time_start;
        //echo "<br />Page $page took $runtime seconds<br />";
    } while (!($finished));
    if ($error_message['message'] != "") {
        $sql = "DELETE FROM `" . $wpdb->prefix . "ama_bannercamp` WHERE id='" . $insertid . "'";
        $wpdb->query($sql);
        echo '<div class="updated" style="margin:0px"><p>' . $error_message['message'] . '</p></div>';
    } else {
        echo '<div class="updated" style="margin:0px"><p>Banner Campaign created successfully.</p></div>';
    }
}

function ama_update_bannerproduct() {

    @ini_set('memory_limit', '256M');
    @set_time_limit(0);
    global $wpdb;
    $data_product = array();
    $count = 0;
    $sql = "select * from " . $wpdb->prefix . "ama_option ";
    $api_data = $wpdb->get_results($sql);
    foreach ($api_data as $apidata) {
        $PublicKey = $apidata->api_key;
        $PrivateKey = $apidata->secret_api_key;
        $des_length = $apidata->amazon_des_length;
        $aff_web = $apidata->amazon_web;
    }
    $sql = "SELECT 
                    bc.*,pr.affweb 
                FROM 
                    `" . $wpdb->prefix . "ama_bannercamp_product` as pr 
                INNER JOIN 
                    `" . $wpdb->prefix . "ama_bannercamp` as bc
                ON 
                    bc.id=pr.camp_id 
                GROUP BY 
                    bc.id";
    $campid = $wpdb->get_results($sql);
    foreach ($campid as $id) {
        $sql = "SELECT asin FROM `" . $wpdb->prefix . "ama_bannercamp_product` WHERE camp_id='" . $id->id . "'";
        $proasin = $wpdb->get_results($sql);
        $arrAsin = array();
        foreach ($proasin as $asin) {
            $arrAsin[] = $asin->asin;
            if (count($arrAsin) >= 10) {
                break;
            }
        }
        $strAsin = implode(',', $arrAsin);
        $xml = ama_aws_request($PrivateKey, $PublicKey, array("Operation" => "ItemLookup",
            "ItemId" => $strAsin,
            "ResponseGroup" => "Small,OfferListings,EditorialReview,VariationSummary",
            "AssociateTag" => $id->affid), $id->affweb);
        if (isset($xml->Error->Code) || isset($xml['error']['message'])) {
            if (isset($xml->Error->Code)) {
                return;
            } else {
                return;
            }
        } else {
            foreach ($xml->Items->Item as $item) {
                $LowestPrice = ama_getamazonprice($item);
                if (isset($item->EditorialReviews->EditorialReview->Content) && isset($item->MediumImage->URL) && $LowestPrice != null) {
                    $arrayupdate['title'] = $item->ItemAttributes->Title;
                    $arrayupdate['desc'] = $item->EditorialReviews->EditorialReview->Content[0];
                    $arrayupdate['price'] = $LowestPrice;
                    $arrayupdate ['link'] = $item->DetailPageURL[0];
                    $tablename = $wpdb->prefix . "ama_bannercamp_product";
                    $where = array('camp_id' => $id->id, 'asin' => $item->ASIN);
                    $wpdb->update($tablename, $arrayupdate, $where);
                }
            }
        }
    }
}

function get_campagin_product_group() {
    global $wpdb;
    $sql = "select camp_id,date from `" . $wpdb->prefix . "ama_bannercamp_product`  group by camp_id";
    $result = $wpdb->get_results($sql);
    return $result;
}

function ama_tinybutton($buttons) {
    array_push($buttons, "separator", "amabannerplugin");
    return $buttons;
}

function ama_tinyregister($plugin_array) {
    $url = AMAZON_URL . "js/ama-tiny.js";
    $plugin_array["amabannerplugin"] = $url;
    return $plugin_array;
}

function ama_banner_shortcode($arg) {
    global $wpdb;
    $sql = "SELECT * FROM `" . $wpdb->prefix . "ama_general_settings`";
    $generalset = $wpdb->get_row($sql);
    $content = "";
    $sql = "SELECT * FROM `" . $wpdb->prefix . "ama_bannercamp` WHERE id='" . $arg['id'] . "' LIMIT 0,1";
    $campdata = $wpdb->get_row($sql);
    $sql = "SELECT * FROM `" . $wpdb->prefix . "ama_bannercamp_product` WHERE camp_id='" . $arg['id'] . "' ORDER BY RAND() LIMIT 0,2";
    $arrProduct = $wpdb->get_results($sql);
    if ($arrProduct) {
        $style = "";
        if (isset($campdata->bstyle) && $campdata->bstyle == 1) {
            $style.="border-radius: 7px 7px 7px 7px;";
        }
        if ($arg['height'] != "")
            $style.="height:".$arg['height']."px;";
        if ($arg['width'] != "")
            $style.="width:".$arg['width']."px;";
        $content.="<div id='amabanner' style='background-color: " . $campdata->bgcolor . ";border: 1px solid " . $campdata->bdcolor . "; " . $style . "'>";
        foreach ($arrProduct as $bannerdata) {
            $amaurl = (isset($generalset->enable_link_cloaking) && $generalset->enable_link_cloaking == 1) ? $bannerdata->clocklink : $bannerdata->link;
            $content.="<div class='banner-container'>";
            $content.="<h2><a href='" . $amaurl . "' target='_blank' style='color:" . $campdata->titcolor . "' >" . substr($bannerdata->title, 0, 50) . "</a></h2>";
            $content.="<p style='color:" . $campdata->txtcolor . "'>" . substr(strip_tags($bannerdata->desc), 0, 110) . "...<br/>Price:" . $bannerdata->price . "</p>";
            $content.="<a href='" . $amaurl . "' target='_blank' style='color:" . $campdata->rmcolor . "' >Read more</a>";
            $content.="</div>";
        }
        $content.="</div>";
    }
    return $content;
}

function ama_camp_banner_list() {
    global $wpdb;
    if (isset($_POST['btnsubmit']) && isset($_POST['delete']) && count($_POST['delete']) > 0) {
        $id = implode(',', $_POST['delete']);
        $sql = "DELETE FROM `" . $wpdb->prefix . "ama_bannercamp_product` WHERE id IN (" . $id . ")";
        $wpdb->query($sql);
    }
    if (isset($_GET['mode']) && $_GET['mode'] == "delete" && isset($_GET['prid'])) {
        $sql = "DELETE FROM `" . $wpdb->prefix . "ama_bannercamp_product` WHERE id='" . $_GET['prid'] . "'";
        $wpdb->query($sql);
    }
    include_once 'pages/camp_banner_list.php';
}

add_shortcode('amazonBanner', 'ama_banner_shortcode');
add_filter('mce_external_plugins', 'ama_tinyregister');
add_filter('mce_buttons', 'ama_tinybutton', 0);
if (!get_option('ama_run_bannerproupdate') || time() - get_option('ama_run_bannerproupdate') >= 86400) {
    add_action('init', 'ama_update_bannerproduct');
    update_option('ama_run_bannerproupdate', time());
}
?>