<?php
require_once('../../../../wp-load.php');
header('Content-Type: text/html; charset=' . get_bloginfo('charset'));
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>
    <head>
        <meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php echo get_option('blog_charset'); ?>" />
        <title><?php _e('Amazon Text Banners') ?></title>
        <script type="text/javascript" src="../js/tiny_mce_popup.js"></script>
        <script type="text/javascript" src="../js/ama-shortcode.js"></script>
        <?php
        wp_admin_css('global', true);
        wp_admin_css('wp-admin', true);
        ?>
        <style type="text/css">
            #wrap {
                padding: 0 15px;
                font-size: 12px;
                margin: 0 auto;
            } #wrap div {
                font-size: 11px;
            } #wrap input {
                margin-bottom: 5px;
            }
        </style>
    </head>
    <body style="height: auto; width: auto;min-width: 400px">
        <div id="wrap">
            <form name="autoresponder" onsubmit="return PasteTextDialog.insert()" action="">
                <h3>Amazon Text Banners</h3>
                <div id="ama_error_msg" style="color:red"></div>
                <table>
                    <tr>
                        <td>Select Your Text Banner Campaign:</td>
                        <td>
                            <select id="ar_code" name="ar_code">
                                <?php
                                global $wpdb;
                                $sql = "SELECT id,campname FROM " . $wpdb->prefix . "ama_bannercamp";
                                $result = $wpdb->get_results($sql);
                                foreach ($result as $likeid) {
                                    echo "<option value='$likeid->id'>" . $likeid->campname . "</option>";
                                }
                                ?>
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <td>Height:</td>
                        <td>
                            <input type="text" id="ama_height" value="" size="5" />
                        </td>
                    </tr>
                    <tr>
                        <td>Width:</td>
                        <td>
                            <input type="text" id="ama_width" value="" size="5" />
                        </td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td>
                            <input type="submit" name="insert" value="{#insert}" id="insert" onclick="return validamapop();"  />
                        </td>
                    </tr>
                </table>
            </form>
        </div>
    </body>
</html>
