<?php
global $wpao_db_version;
$wpao_db_version = "3.0";

function wpao_install() {
   global $wpdb;
   global $wpao_db_version;

    $table_name = $wpdb->prefix . "ama_bannercamp";
    $sql = "CREATE TABLE $table_name  (
        `id` INT(11) NOT NULL AUTO_INCREMENT,
        `affid` VARCHAR(300) NOT NULL,
        `campname` VARCHAR(300) NOT NULL,
        `amadep` VARCHAR(300) NOT NULL,
        `keyword` VARCHAR(300) NOT NULL,
        `bgcolor` VARCHAR(20) NULL DEFAULT NULL,
        `bdcolor` VARCHAR(20) NULL DEFAULT NULL,
        `titcolor` VARCHAR(20) NULL DEFAULT NULL,
        `txtcolor` VARCHAR(20) NULL DEFAULT NULL,
        `rmcolor` VARCHAR(20) NULL DEFAULT NULL,
        `bstyle` INT(2) NOT NULL,
        `height` INT(5) NOT NULL,
        `width` INT(5) NOT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    $table_name = $wpdb->prefix . "ama_bannercamp_product";
    $sql = "CREATE TABLE $table_name  (
        `id` INT(11) NOT NULL AUTO_INCREMENT,
        `camp_id` INT(11) NOT NULL,
        `title` VARCHAR(500) NOT NULL,
        `desc` LONGTEXT NOT NULL,
        `link` VARCHAR(400) NOT NULL,
        `price` VARCHAR(200) NOT NULL,
        `clocklink` VARCHAR(400) NOT NULL,
        `date` INT(20) NOT NULL,
        `asin` VARCHAR(300) NULL DEFAULT NULL,
        `affweb` VARCHAR(50) NULL DEFAULT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);


    $table_name = $wpdb->prefix . "ama_campaigns";
    $sql = "CREATE TABLE $table_name  (
        `cam_id` INT(11) NOT NULL AUTO_INCREMENT,
        `cam_apiid` VARCHAR(50) NULL DEFAULT NULL,
        `cam_name` VARCHAR(50) NULL DEFAULT NULL,
        `cam_department` VARCHAR(100) NULL DEFAULT NULL,
        `cam_browsenode` INT(11) NULL DEFAULT NULL,
        `cam_keywords` VARCHAR(100) NULL DEFAULT NULL,
        `cam_categories` VARCHAR(100) NULL DEFAULT NULL,
        `cam_interval` INT(11) NULL DEFAULT NULL,
        `cam_interval_type` VARCHAR(10) NULL DEFAULT NULL,
        `cam_number_post` INT(11) NULL DEFAULT NULL,
        `cam_post_created` INT(11) NULL DEFAULT '0',
        `cam_status` INT(2) NULL DEFAULT '0',
        `cam_created_time` DATETIME NULL DEFAULT NULL,
        `cam_last_time` DATETIME NULL DEFAULT NULL,
        `cam_encoding` INT(1) NULL DEFAULT '0',
        `cam_minprice` VARCHAR(10) NULL DEFAULT NULL,
        `cam_maxprice` VARCHAR(10) NULL DEFAULT NULL,
        `cam_keytype` INT(2) NOT NULL DEFAULT '0',
        `cam_parent_page` INT(11) NULL DEFAULT NULL,
        `cam_asin_code` TEXT NULL,
        `cam_similar_items` INT(1) NULL DEFAULT NULL,
        `cam_similar_count` INT(1) NULL DEFAULT NULL,
        `cam_no_desc` INT(1) NULL DEFAULT NULL,
        `cam_timetype` INT(2) NULL DEFAULT NULL,
        `cam_custom_desc` VARCHAR(5000) NULL DEFAULT NULL,
        `cam_postformat` INT(2) NULL DEFAULT NULL,
        `cam_btnformat` INT(2) NULL DEFAULT NULL,
        `campost_type` VARCHAR(10) NULL DEFAULT NULL,
        `campagename` VARCHAR(500) NULL DEFAULT NULL,
        `video` INT(2) NULL DEFAULT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    $table_name = $wpdb->prefix . "ama_campaigns_post";
    $sql = "CREATE TABLE $table_name  (
        `cam_postid` INT(11) NOT NULL AUTO_INCREMENT,
        `cam_camid` INT(11) NULL DEFAULT NULL,
        `cam_camproductid` VARCHAR(30) NULL DEFAULT NULL,
        `post_ID` BIGINT(20) UNSIGNED NOT NULL,
        `cam_capiid` VARCHAR(50) NULL DEFAULT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    $table_name = $wpdb->prefix . "ama_campaign_presets";
    $sql = "CREATE TABLE $table_name  (
        `cam_id` INT(11) NOT NULL AUTO_INCREMENT,
        `cam_apiid` VARCHAR(50) NULL DEFAULT NULL,
        `cam_name` VARCHAR(50) NULL DEFAULT NULL,
        `cam_department` VARCHAR(100) NULL DEFAULT NULL,
        `cam_browsenode` INT(11) NULL DEFAULT NULL,
        `cam_keywords` VARCHAR(100) NULL DEFAULT NULL,
        `cam_categories` VARCHAR(100) NULL DEFAULT NULL,
        `cam_interval` INT(11) NULL DEFAULT NULL,
        `cam_interval_type` VARCHAR(10) NULL DEFAULT NULL,
        `cam_number_post` INT(11) NULL DEFAULT NULL,
        `cam_post_created` INT(11) NULL DEFAULT NULL,
        `cam_status` INT(2) NULL DEFAULT NULL,
        `cam_created_time` DATETIME NULL DEFAULT NULL,
        `cam_last_time` DATETIME NULL DEFAULT NULL,
        `cam_post_now` INT(1) NULL DEFAULT NULL,
        `cam_encoding` INT(1) NULL DEFAULT NULL,
        `cam_minprice` VARCHAR(10) NULL DEFAULT NULL,
        `cam_maxprice` VARCHAR(10) NULL DEFAULT NULL,
        `cam_keytype` INT(2) NULL DEFAULT NULL,
        `cam_timetype` INT(2) NULL DEFAULT NULL,
        `newcat` INT(1) NOT NULL,
        `cam_postformat` INT(2) NULL DEFAULT NULL,
        `cam_btnformat` INT(2) NULL DEFAULT NULL,
        `campost_type` VARCHAR(10) NULL DEFAULT NULL,
        `campagename` VARCHAR(500) NULL DEFAULT NULL,
        `cam_asin_code` TEXT NULL,
        `cam_similar_items` INT(1) NULL DEFAULT NULL,
        `cam_similar_count` INT(1) NULL DEFAULT NULL,
        `cam_no_desc` INT(1) NULL DEFAULT NULL,
        `cam_custom_desc` VARCHAR(1000) NULL DEFAULT NULL,
        `cam_parent_page` INT(11) NULL DEFAULT NULL,
        `video` INT(2) NULL DEFAULT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    $table_name = $wpdb->prefix . "ama_camp_prodata";
    $sql = "CREATE TABLE $table_name  (
        `id` INT(11) NOT NULL AUTO_INCREMENT,
        `campid` INT(10) NULL DEFAULT NULL,
        `asin` VARCHAR(100) NULL DEFAULT NULL,
        `link` VARCHAR(400) NULL DEFAULT NULL,
        `price` VARCHAR(25) NULL DEFAULT NULL,
        `timestamp` VARCHAR(100) NULL DEFAULT NULL,
        `des` LONGTEXT NULL,
        `imgurl` LONGTEXT NULL,
        `clockurl` VARCHAR(400) NULL DEFAULT NULL,
        `web` VARCHAR(20) NULL DEFAULT NULL,
        `title` VARCHAR(300) NULL DEFAULT NULL,
        `affid` VARCHAR(100) NULL DEFAULT NULL,
        `camtype` INT(2) NOT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    $table_name = $wpdb->prefix . "ama_general_settings";
    $sql = "CREATE TABLE $table_name  (
        `enable_review` INT(1) UNSIGNED NOT NULL DEFAULT '0',
        `enabe_review_only_post` INT(1) NULL DEFAULT NULL,
        `enable_link_cloaking` INT(1) NULL DEFAULT NULL,
        `enable_popup` INT(1) NULL DEFAULT NULL,
        `popup_id` CHAR(50) NULL DEFAULT NULL,
        `popup_delay` INT(3) NULL DEFAULT NULL,
        `popup_bg` CHAR(7) NULL DEFAULT NULL,
        `popup_txt` CHAR(7) NULL DEFAULT NULL,
        `popup_bd` CHAR(7) NULL DEFAULT NULL,
        `popup_rm` CHAR(7) NULL DEFAULT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    $table_name = $wpdb->prefix . "ama_option";
    $sql = "CREATE TABLE $table_name  (
        `aff_id` INT(11) NOT NULL,
        `api_key` VARCHAR(200) NULL DEFAULT NULL,
        `secret_api_key` VARCHAR(200) NULL DEFAULT NULL,
        `amazon_des_length` INT(11) NULL DEFAULT NULL,
        `amazon_web` VARCHAR(10) NULL DEFAULT NULL,
        `btnformate` INT(2) NULL DEFAULT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    $table_name = $wpdb->prefix . "ama_popcamp";
    $sql = "CREATE TABLE $table_name  (
        `id` INT(11) NOT NULL AUTO_INCREMENT,
        `affid` VARCHAR(100) NOT NULL,
        `department` VARCHAR(50) NOT NULL,
        `keyword` VARCHAR(100) NOT NULL,
        `numpop` INT(5) NOT NULL,
        `button` INT(5) NOT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    $table_name = $wpdb->prefix . "ama_similar";
    $sql = "CREATE TABLE $table_name  (
        `asin` TINYTEXT NULL,
        `aurl` TEXT NULL,
        `cloakedurl` TINYTEXT NULL,
        `title` TEXT NULL,
        `mainproduct` TINYTEXT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    $table_name = $wpdb->prefix . "ama_uniquepost";
    $sql = "CREATE TABLE $table_name  (
        `id` INT(11) NOT NULL AUTO_INCREMENT,
        `postid` INT(11) NOT NULL,
        `campid` INT(11) NOT NULL
    );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
    update_option("wpao_db_version", $wpao_db_version);
}

function wpao_update_db_check() {
    global $wpao_db_version;
    if (get_site_option('wpao_db_version') != $wpao_db_version) {
        wpao_install();
    }
}
add_action('plugins_loaded', 'wpao_update_db_check');
